VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H009E958F&
   Caption         =   "Brush buffer"
   ClientHeight    =   2430
   ClientLeft      =   75
   ClientTop       =   360
   ClientWidth     =   3360
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Brush_test.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   162
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   224
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Restore"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00BEC1D8&
      Height          =   225
      Left            =   45
      TabIndex        =   0
      Top             =   60
      Width           =   675
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Restore"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   225
      Left            =   60
      TabIndex        =   1
      Top             =   75
      Width           =   675
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public Sub DisplayBrush()




'add some to the size because of the window bars and gadgets
Form1.Width = (tw + 10) * Screen.TwipsPerPixelX
Form1.Height = (th + 28) * Screen.TwipsPerPixelY
Form1.Show


'dim the buffers
ReDim brushRBuffer(tw, th)
ReDim brushGBuffer(tw, th)
ReDim brushBBuffer(tw, th)
ReDim brushABuffer(tw, th)
brushRBuffer() = Dogwaffle.Dog_GetBrushRBuffer
brushGBuffer() = Dogwaffle.Dog_GetBrushGBuffer
brushBBuffer() = Dogwaffle.Dog_GetBrushBBuffer
brushABuffer() = Dogwaffle.Dog_GetBrushABuffer



Dim cb As Long
'make an array to hold the chekerboard with 4 entries.
Dim board(2, 2) As Byte
board(0, 0) = 128
board(0, 1) = 190
board(1, 0) = 190
board(1, 1) = 128

Dim a2 As Single
Dim MyHDC As Long
MyHDC = Me.hdc
Dim x As Long
Dim y As Long
Dim r As Long, g As Long, b As Long

Dim a As Long

For y = 0 To th - 1
    For x = 0 To tw - 1
        r = brushRBuffer(x, y)
        g = brushGBuffer(x, y)
        b = brushBBuffer(x, y)
        a = brushABuffer(x, y)
        a2 = a / 256
        'make the alpha show as a checkerboard
        cb = board(Int(x / 16) Mod 2, Int(y / 16) Mod 2)
        r = (r * a2) + (cb * (1 - a2))
        g = (g * a2) + (cb * (1 - a2))
        b = (b * a2) + (cb * (1 - a2))
        SetPixel MyHDC, x, y, RGB(r, g, b)
    Next
    'set the progress bar for each full line
    'Call Dogwaffle.Dog_SetProgress(y * (100 / th))
Next

'allways reset the progress bar if your using it. (and you should)
'Dogwaffle.Dog_SetProgress 0
End Sub
Private Sub Form_Load()

DisplayBrush


End Sub

Private Sub Label1_Click()

Form1.WindowState = 1

result = Dogwaffle.Dog_QuestionBox("The current brush will be overwritten.")

Form1.WindowState = 0

If result = 1 Then

'create the new brush
Dogwaffle.Dog_CreateEmptyBrush tw, th
'sent the buffers
Dogwaffle.Dog_SetBrushRBuffer brushRBuffer()
Dogwaffle.Dog_SetBrushGBuffer brushGBuffer()
Dogwaffle.Dog_SetBrushBBuffer brushBBuffer()
Dogwaffle.Dog_SetBrushABuffer brushABuffer()
'activate the brush tool
Dogwaffle.Dog_ActivateCustomBrush
End If


End Sub
