Attribute VB_Name = "Module1"
Public Sub Main()

'render noise that looks more like film noise


Dim x As Integer, y As Integer
Dim r As Long, g As Long, b As Long

'allocate the main buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")


Dim v As Single
v = Dogwaffle.dog_ValueBox("Value", 0, 255)


'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer

'process the buffers.
'in this case, a negative effect.
  For y = 0 To th - 1
   For x = 0 To tw - 1
      r = MainRBuffer(x, y)
      g = MainGBuffer(x, y)
      b = MainBBuffer(x, y)
      r = r + ((Rnd - 0.5) * (v * 0.3))
      b = b + ((Rnd - 0.5) * (v * 0.5))
      g = g + ((Rnd - 0.5) * (v * 0.2))
      If r > 255 Then r = 255
      If g > 255 Then g = 255
      If b > 255 Then b = 255
        If r < 0 Then r = 0
        If g < 0 Then g = 0
        If b < 0 Then b = 0
      MainRBuffer(x, y) = r
      MainGBuffer(x, y) = g
      MainBBuffer(x, y) = b
    Next
     If (y Mod 20) = 1 Then Dogwaffle.Dog_SetProgress y * (100 / th)
  Next
  
  Dogwaffle.Dog_SetProgress 0

'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()

'and refresh the screen
Dogwaffle.Dog_Refresh

End Sub

