Attribute VB_Name = "Module1"

Sub Main()
'*** Minimize FILTER EXAMPLE ***
'dogwaffle should be running when this code is executed.

Dim x As Integer, y As Integer
Dim x2 As Integer, y2 As Integer
'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim r2 As Long, g2 As Long, b2 As Long
Dim r3 As Long, g3 As Long, b3 As Long
Dim r4 As Long, g4 As Long, b4 As Long
Dim r5 As Long, g5 As Long, b5 As Long
Dim sr As Long, sg As Long, sb As Long

Dim alphabits As Byte

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")

Dim ystp As Integer

'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
alphabits = Dogwaffle.Dog_GetAlphabits
'get a copy of the main buffers
Dim sRBuffer() As Byte
Dim sGBuffer() As Byte
Dim sBBuffer() As Byte
sRBuffer() = MainRBuffer()
sGBuffer() = MainGBuffer()
sBBuffer() = MainBBuffer()

'process the buffers.
For y = 1 To th - 2
    For x = 1 To tw - 2

        a = MainABuffer(x - 1, y)
        r = sRBuffer(x, y)
        g = sGBuffer(x, y)
        b = sBBuffer(x, y)
        sr = r
        sg = g
        sb = b
        r2 = sRBuffer(x - 1, y)
        g2 = sGBuffer(x - 1, y)
        b2 = sBBuffer(x - 1, y)
        r3 = sRBuffer(x, y - 1)
        g3 = sGBuffer(x, y - 1)
        b3 = sBBuffer(x, y - 1)
        r4 = sRBuffer(x + 1, y)
        g4 = sGBuffer(x + 1, y)
        b4 = sBBuffer(x + 1, y)
        r5 = sRBuffer(x, y + 1)
        g5 = sGBuffer(x, y + 1)
        b5 = sBBuffer(x, y + 1)
        '

        'get the maximum
        If r2 < r Then r = r2
        If g2 < g Then g = g2
        If b2 < b Then b = b2
        '
        If r3 < r Then r = r3
        If g3 < g Then g = g3
        If b3 < b Then b = b3
        '
        If r4 < r Then r = r4
        If g4 < g Then g = g4
        If b4 < b Then b = b4
        '
        If r5 < r Then r = r5
        If g5 < g Then g = g5
        If b5 < b Then b = b5
        
        'handle alpha channel
        a = a Or alphabits 'if there's an alhpa but it's disabled
        a2 = 255 - a
        r = ((sr * a2) + (r * a)) / 255
        g = ((sg * a2) + (g * a)) / 255
        b = ((sb * a2) + (b * a)) / 255
         
        MainRBuffer(x, y) = r
        MainGBuffer(x, y) = g
        MainBBuffer(x, y) = b
        
    Next x
    ystp = ystp + 1
    If ystp >= 10 Then
    ystp = 0
    Call Dogwaffle.Dog_SetProgress((y * (100 / th)))
    End If
Next y

'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()
Dogwaffle.Dog_Refresh

'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

End Sub

