Attribute VB_Name = "Module1"




Sub Main()


Dim x As Integer, y As Integer


Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim r2 As Long, g2 As Long, b2 As Long
Dim n As Long, n2 As Long
Dim OldPointer As Integer

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")

'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
'Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
'MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
'alphabits = Dogwaffle.Dog_GetAlphabits



'convert to 12 bits simply by dropping the last 3 bits of each color
Dim difr As Integer, difg As Integer, difb As Integer


'oh, lets use floyd-Steinberg error diffusion.

For y = 0 To th
 For x = 0 To tw
 r = MainRBuffer(x, y)
 g = MainGBuffer(x, y)
 b = MainBBuffer(x, y)
 r2 = (r And 240) 'or &HFF-15
 g2 = (g And 240)
 b2 = (b And 240)
 'dithering...
 difr = r - r2
 difg = g - g2
 difb = b - b2
 '
 X2 = x Mod 15
 Y2 = y Mod 15
 'if were we using the dither table from above
 'If difr <= (dither(X2, Y2)) Then r = r2 Else r = r2 + 16
 'If difg <= (dither(X2, Y2)) Then g = g2 Else g = g2 + 16
 'If difb <= (dither(X2, Y2)) Then b = b2 Else b = b2 + 16
 'otherwise, just use some random noise
 'this should be remove if using dither table code above...
    Dim myrand As Integer
    myrand = (Rnd * 16)
    If difr <= myrand Then r = r2 Else r = r2 + 16
    If difg <= myrand Then g = g2 Else g = g2 + 16
    If difb <= myrand Then b = b2 Else b = b2 + 16
 If r > 255 Then r = 255
 If g > 255 Then g = 255
 If b > 255 Then b = 255
 MainRBuffer(x, y) = r
 MainGBuffer(x, y) = g
 MainBBuffer(x, y) = b
 Next
Next






'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()
Dogwaffle.Dog_Refresh




'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

'Dogwaffle.dog_SetMousePointer (OldPointer)
'Dogwaffle.Dog_unLock



End Sub





Public Function ShiftR(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftR = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e \ 2
Next

ShiftR = e

End Function

Public Function ShiftL(ByVal e As Long, ByVal v As Long) As Long
'this is way slower than hardware shift, but I'm sick on not having shift support in vb
If v = 0 Then ShiftL = e: Exit Function

Dim n As Long
For n = 0 To v - 1
e = e * 2
Next

ShiftL = e

End Function



