Attribute VB_Name = "Module1"




Sub Main()


Dim x As Integer, y As Integer


Dim r As Single, g As Single, b As Single
Dim r2 As Single, g2 As Single, b2 As Single
Dim r3 As Single, g3 As Single, b3 As Single
Dim n As Long, n2 As Long
Dim OldPointer As Integer

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")

'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

Dim tRBuffer() As Byte
Dim tGBuffer() As Byte
Dim tBBuffer() As Byte

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
ReDim MainRBuffer(tw, th)
ReDim MainGBuffer(tw, th)
ReDim MainBBuffer(tw, th)

'Dim MainABuffer() As Byte
tRBuffer() = Dogwaffle.Dog_GetRBuffer
tGBuffer() = Dogwaffle.Dog_GetGBuffer
tBBuffer() = Dogwaffle.Dog_GetBBuffer
'
For y = 0 To th
 For x = 0 To tw
  MainRBuffer(x, y) = tRBuffer(x, y)
  MainGBuffer(x, y) = tGBuffer(x, y)
  MainBBuffer(x, y) = tBBuffer(x, y)
 Next
Next
  
'
'get copy
Dim TempRBuffer() As Single
Dim TempGBuffer() As Single
Dim TempBBuffer() As Single
ReDim TempRBuffer(tw, th)
ReDim TempGBuffer(tw, th)
ReDim TempBBuffer(tw, th)
'
For y = 0 To th
 For x = 0 To tw
  TempRBuffer(x, y) = MainRBuffer(x, y)
  TempGBuffer(x, y) = MainGBuffer(x, y)
  TempBBuffer(x, y) = MainBBuffer(x, y)
 Next
Next


'convert to 12 bits simply by dropping the last 4 bits of each color
Dim difr As Single, difg As Single, difb As Single


'oh, lets use floyd-Steinberg error diffusion.
'sure it's a bit messy.  My next one will be much better.

Dim zagx As Long, zaglow As Long, zaghigh As Long
Dim LeftovertermR As Single
Dim LeftovertermG As Single
Dim LeftovertermB As Single

For y = 0 To th - 1
If ((y \ 2) * 2) = y Then zagx = 1: zaglow = 1: zaghigh = tw - 1 Else zagx = -1: zaglow = tw - 1: zaghigh = 1
 For x = zaglow To zaghigh Step zagx
 
 'If zagx = -1 Then GoTo Skip
 
 r = TempRBuffer(x, y)
 g = TempGBuffer(x, y)
 b = TempBBuffer(x, y)
 '
 r2 = Int(((r \ 16) * 16) * 1.0588) 'adjust for missing 15 steps
 g2 = Int(((g \ 16) * 16) * 1.0588)
 b2 = Int(((b \ 16) * 16) * 1.0588)

 'find difference
 difr = (r - r2)
 difg = (g - g2)
 difb = (b - b2)
 '
 If r2 > 255 Then r2 = 255
 If r2 < 0 Then r2 = 0
 If g2 > 255 Then g2 = 255
 If g2 < 0 Then g2 = 0
 If b2 > 255 Then b2 = 255
 If b2 < 0 Then b2 = 0
 MainRBuffer(x, y) = r2
 MainGBuffer(x, y) = g2
 MainBBuffer(x, y) = b2
'step1
r3 = (TempRBuffer(x + zagx, y) + ((7 * difr) / 16))
g3 = (TempGBuffer(x + zagx, y) + ((7 * difg) / 16))
b3 = (TempBBuffer(x + zagx, y) + ((7 * difb) / 16))
LeftovertermR = ((7 * difr) / 16)
LeftovertermG = ((7 * difg) / 16)
LeftovertermB = ((7 * difb) / 16)
'If r3 > 255 Then r3 = 255
'If g3 > 255 Then g3 = 255
'If b3 > 255 Then b3 = 255
'If r3 < 0 Then r3 = 0
'If g3 < 0 Then g3 = 0
'If b3 < 0 Then b3 = 0
TempRBuffer(x + zagx, y) = r3
TempGBuffer(x + zagx, y) = g3
TempBBuffer(x + zagx, y) = b3
'step2
r3 = (TempRBuffer(x - zagx, y + 1) + ((3 * difr) / 16))
g3 = (TempGBuffer(x - zagx, y + 1) + ((3 * difg) / 16))
b3 = (TempBBuffer(x - zagx, y + 1) + ((3 * difb) / 16))
LeftovertermR = LeftovertermR + ((3 * difr) / 16)
LeftovertermG = LeftovertermG + ((3 * difg) / 16)
LeftovertermB = LeftovertermB + ((3 * difb) / 16)
'If r3 > 255 Then r3 = 255
'If g3 > 255 Then g3 = 255
'If b3 > 255 Then b3 = 255
'If r3 < 0 Then r3 = 0
'If g3 < 0 Then g3 = 0
'If b3 < 0 Then b3 = 0
TempRBuffer(x - zagx, y + 1) = r3
TempGBuffer(x - zagx, y + 1) = g3
TempBBuffer(x - zagx, y + 1) = b3
'step3
r3 = (TempRBuffer(x, y + 1) + ((5 * difr) / 16))
g3 = (TempGBuffer(x, y + 1) + ((5 * difg) / 16))
b3 = (TempBBuffer(x, y + 1) + ((5 * difb) / 16))
LeftovertermR = LeftovertermR + ((5 * difr) / 16)
LeftovertermG = LeftovertermG + ((5 * difg) / 16)
LeftovertermB = LeftovertermB + ((5 * difb) / 16)
'If r3 > 255 Then r3 = 255
'If g3 > 255 Then g3 = 255
'If b3 > 255 Then b3 = 255
'If r3 < 0 Then r3 = 0
'If g3 < 0 Then g3 = 0
'If b3 < 0 Then b3 = 0
TempRBuffer(x, y + 1) = r3
TempGBuffer(x, y + 1) = g3
TempBBuffer(x, y + 1) = b3
'step 4
difr = difr - LeftovertermR
difg = difg - LeftovertermG
difb = difb - LeftovertermB
'If difr < 0 Then MsgBox (Str(x) + "  " + Str(y)): Stop
r3 = (TempRBuffer(x + zagx, y + 1) + (difr))
g3 = (TempGBuffer(x + zagx, y + 1) + (difg))
b3 = (TempBBuffer(x + zagx, y + 1) + (difb))
'If r3 > 255 Then r3 = 255
'If g3 > 255 Then g3 = 255
'If b3 > 255 Then b3 = 255
'If r3 < 0 Then r3 = 0
'If g3 < 0 Then g3 = 0
'If b3 < 0 Then b3 = 0
TempRBuffer(x + zagx, y + 1) = r3
TempGBuffer(x + zagx, y + 1) = g3
TempBBuffer(x + zagx, y + 1) = b3
'Skip:
 Next
Next





For y = 0 To th
 For x = 0 To tw
  If (MainRBuffer(x, y) > 255) Then MainRBuffer(x, y) = 255
  tRBuffer(x, y) = CInt(MainRBuffer(x, y))
  If (MainGBuffer(x, y) > 255) Then MainGBuffer(x, y) = 255
  tGBuffer(x, y) = CInt(MainGBuffer(x, y))
  If (MainBBuffer(x, y) > 255) Then MainBBuffer(x, y) = 255
  tBBuffer(x, y) = CInt(MainBBuffer(x, y))
 Next
Next
'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer tRBuffer()
Dogwaffle.Dog_SetGbuffer tGBuffer()
Dogwaffle.Dog_SetBbuffer tBBuffer()
Dogwaffle.Dog_Refresh




'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

'Dogwaffle.dog_SetMousePointer (OldPointer)
'Dogwaffle.Dog_unLock



End Sub






