Attribute VB_Name = "Module1"

Sub Main()
'*** change the size of the brush key with a morpholocial process ***

'dogwaffle should be running when this code is executed.

Dim x As Integer, y As Integer
Dim x2 As Integer, y2 As Integer
'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim a As Long
Dim a2 As Long
Dim a3 As Long
Dim a4 As Long
Dim a5 As Long
Dim ar As Long

'create a dogwaffle object (this is the interface to dogwaffles functions)
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")


'get the width and height of the buffer
th = Dogwaffle.Dog_GetBrushHeight
tw = Dogwaffle.Dog_GetBrushWidth

If tw = 0 Then Dogwaffle.dog_messagebox ("No brush"): Exit Sub

'get the buffers

Dim BrushABuffer() As Byte
BrushABuffer() = Dogwaffle.Dog_GetBrushABuffer 'alpha

'get a copy of the main buffers
Dim sABuffer() As Byte
sABuffer() = BrushABuffer()

Dim ystp

'process the buffers.
For y = 1 To th - 2
    For x = 1 To tw - 2

        a = sABuffer(x - 1, y)
        a2 = sABuffer(x - 1, y)
        a3 = sABuffer(x, y - 1)
        a4 = sABuffer(x + 1, y)
        a5 = sABuffer(x, y + 1)
        '
        'get the maximum
        If a2 < a Then a = a2
        '
        If a3 < a Then a = a3
        '
        If a4 < a Then a = a4
        '
        If a5 < a Then a = a5
        
        BrushABuffer(x, y) = a

    Next
            'set the progress bar for each full line
    ystp = ystp + 1
    If ystp >= 10 Then
    ystp = 0
    Call Dogwaffle.Dog_SetProgress((y * (100 / th)))
    End If
Next

'send the buffers back to dogwaffle.
Dogwaffle.Dog_Setbrushabuffer BrushABuffer()


'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0

End Sub

