Attribute VB_Name = "Module1"
Public Dogwaffle As Object

Public Type bmfileheader
bfType1 As Byte
bftype2 As Byte
bfSize As Long
bfReserved1 As Integer
bfReserved2 As Integer
bfOffBits As Long
End Type

Public Type Bmheader
biSize As Long
biWidth As Long
biHeight As Long
biPlanes As Integer
biBitcount As Integer
biCompression As Long
biSizeImage As Long
biXpelsPerMeter As Long
biYPelsPerMeter As Long
biClrUsed As Long
biClrImportant As Long
'not sure if there should be a bmiColors entry since there's no color map?

End Type


Sub Main()
'create a dogwaffle object

Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")
tw = Dogwaffle.Dog_GetBrushWidth
If tw = 0 Then Dogwaffle.dog_Messagebox ("No brush"): Exit Sub
SaveBMP_TEMP
Clipboard.Clear
Clipboard.SetData LoadPicture("Temp_Clipboard_object.bmp")
Kill ("Temp_Clipboard_object.bmp")

End Sub



Sub SaveBMP_TEMP()


Dim x As Integer, y As Integer
Dim r As Long, g As Long, b As Long
Dim c As Long






'dim the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
Dim BMPBuffer() As Byte



'open the file requester in dogwaffle
MyFilename = "Temp_Clipboard_object.bmp"


Dim tw As Integer, th As Integer
tw = Dogwaffle.Dog_GetBrushWidth
th = Dogwaffle.Dog_GetBrushHeight


'dim the buffers
ReDim MainRBuffer(tw, th)
ReDim MainGBuffer(tw, th)
ReDim MainBBuffer(tw, th)

'dim the output buffer
'remember that bmps are long word aligned.
MyWidth = (tw * 3)
dif = MyWidth - (Int(MyWidth / 4) * 4)
If dif = 1 Then MyWidth = MyWidth + 3
If dif = 2 Then MyWidth = MyWidth + 2
If dif = 3 Then MyWidth = MyWidth + 1
ReDim BMPBuffer(MyWidth - 1, th - 1)


'get the buffers from dogwaffle
MainRBuffer() = Dogwaffle.Dog_GetBrushRBuffer
MainGBuffer() = Dogwaffle.Dog_GetBrushGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBrushBBuffer

Dim y2 As Integer
Dim x2 As Integer
'format the output buffer
For y = 0 To th - 1
y2 = (th - 1) - y
x2 = 0
    For x = 0 To tw - 1

        r = MainRBuffer(x, y2)
        g = MainGBuffer(x, y2)
        b = MainBBuffer(x, y2)
        
        BMPBuffer(x2, y) = b
        x2 = x2 + 1
        BMPBuffer(x2, y) = g
        x2 = x2 + 1
        BMPBuffer(x2, y) = r
        x2 = x2 + 1
        
        
        
        Next
    'set the progress bar
    If (y Mod 4) = 0 Then Call Dogwaffle.Dog_SetProgress(y * (100 / th))
Next

'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0


On Error GoTo SkipAll

'fill out the bmfileheader and bmheader
Dim bmfh As bmfileheader
bmfh.bfType1 = Asc("B")
bmfh.bftype2 = Asc("M")
bmfh.bfSize = (tw * 4)          'was getting overflow, so broke it up.
bmfh.bfSize = bmfh.bfSize * th  'size of file
bmfh.bfSize = bmfh.bfSize + 54  '
bmfh.bfOffBits = 54 'offset in file were bitmap begins
Dim bmh As Bmheader
bmh.biSize = 40
bmh.biWidth = tw
bmh.biHeight = th
bmh.biPlanes = 1
bmh.biBitcount = 24
bmh.biCompression = 0
bmh.biSizeImage = 0

'open the file and output the structures and bitmap buffer
Open MyFilename For Binary Access Write As #1
Put #1, , bmfh
Put #1, , bmh
Put #1, , BMPBuffer


SkipAll:
Close
On Error GoTo 0



End Sub

