Attribute VB_Name = "Module1"
Public Dogwaffle As Object

'dim the buffers
Public brushRBuffer() As Byte
Public brushGBuffer() As Byte
Public brushBBuffer() As Byte
Public brushABuffer() As Byte
'
Public MainRBuffer() As Byte
Public MainGBuffer() As Byte
Public MainBBuffer() As Byte
Public MainABuffer() As Byte

Public tw As Integer
Public th As Integer
Public BrushW As Integer
Public BrushH As Integer



Sub Main()
'*** GENERIC BRUSH ACCESS EXAMPLE ***
'pretty much the same as accessing the main buffers.




'create a dogwaffle object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")


Dummy = Dogwaffle.Dog_QuestionBox("This plugin exchanges the Main buffer with the current custom brush.  The swap buffer will be lost.  Shall I proceed?")
If Dummy = 2 Then Exit Sub


'get the buffer size
tw = Dogwaffle.Dog_BufferWidth
th = Dogwaffle.Dog_BufferHeight
'get the brush size
BrushW = Dogwaffle.Dog_GetBrushWidth
BrushH = Dogwaffle.Dog_GetBrushHeight

'exit if no brush
If BrushW = 0 Then Exit Sub


'dim the buffers
ReDim MainRBuffer(tw, th)
ReDim MainGBuffer(tw, th)
ReDim MainBBuffer(tw, th)
ReDim MainABuffer(tw, th)
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
MainABuffer() = Dogwaffle.Dog_GetABuffer
'and the brush
ReDim brushRBuffer(BrushW, BrushH)
ReDim brushGBuffer(BrushW, BrushH)
ReDim brushBBuffer(BrushW, BrushH)
ReDim brushABuffer(BrushW, BrushH)
brushRBuffer() = Dogwaffle.Dog_GetBrushRBuffer
brushGBuffer() = Dogwaffle.Dog_GetBrushGBuffer
brushBBuffer() = Dogwaffle.Dog_GetBrushBBuffer
brushABuffer() = Dogwaffle.Dog_GetBrushABuffer

'create the new buffer
Dogwaffle.Dog_NewBuffer BrushW, BrushH
'create the new brush
Dogwaffle.Dog_CreateEmptyBrush tw, th
'send the buffers
Dogwaffle.Dog_SetBrushRBuffer MainRBuffer()
Dogwaffle.Dog_SetBrushGBuffer MainGBuffer()
Dogwaffle.Dog_SetBrushBBuffer MainBBuffer()
Dogwaffle.Dog_SetBrushABuffer MainABuffer()
'
Dogwaffle.Dog_SetRBuffer brushRBuffer()
Dogwaffle.Dog_SetGBuffer brushGBuffer()
Dogwaffle.Dog_SetBBuffer brushBBuffer()
Dogwaffle.Dog_SetABuffer brushABuffer()

'refresh the screen
Dogwaffle.Dog_Refresh


Dummy = Dogwaffle.Dog_QuestionBox("Shall I store the new custom brush while I'm at it?")
If Dummy = 2 Then Exit Sub
'executing another plugin is really darn simple.
Shell ("Store_Brush_pb.exe")






End Sub

