Attribute VB_Name = "Module1"
Public Sub Main()

'a not-very-fast version of the 'count colors' algorithm.
'basically counts the color use of neiboring pixels and uses the most common.

Dim x As Long, y As Long
Dim x2 As Long, y2 As Long
Dim x3 As Long, y3 As Long
Dim r As Long, g As Long, b As Long
Dim n As Long


'allocate the main buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte

Dim tRBuffer() As Byte
Dim tGBuffer() As Byte
Dim tBBuffer() As Byte

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")


Dim v As Long
v = Dogwaffle.dog_ValueBox2("Propagate values", "Intensity", 1, 4, 2)
If v = -1 Then Exit Sub

'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
tRBuffer = MainRBuffer
tGBuffer = MainGBuffer
tBBuffer = MainBBuffer


'quantize a little
  For y = 0 To th - 1
   For x = 0 To tw - 1
    tRBuffer(x, y) = Int(tRBuffer(x, y) \ 8) * 8
    tGBuffer(x, y) = Int(tGBuffer(x, y) \ 8) * 8
    tBBuffer(x, y) = Int(tBBuffer(x, y) \ 8) * 8
   Next
  Next


Dim mcolor() As Long
Dim v2 As Long
v2 = (v * 2) + 1
ReDim mcolor((v2 * v2) - 1, 1)
Dim mcount As Long


'process the buffers.

Dim tempcolor As Long
  For y = 0 To th - 1
   For x = 0 To tw - 1

      mcount = 0
      For y2 = (y - v) To (y + v)
      y3 = y2
      If y3 < 0 Then y3 = 0
      If y3 > th Then y3 = th
        For x2 = (x - v) To (x + v)
        x3 = x2
        If x3 < 0 Then x3 = 0
        If x3 > tw Then x3 = tw
        '
        r = tRBuffer(x3, y3)
        g = tGBuffer(x3, y3)
        b = tBBuffer(x3, y3)
        
        mcolor(mcount, 0) = RGB(r, g, b)
        mcolor(mcount, 1) = 0
        mcount = mcount + 1
       Next
      Next
        '
      'find the color that's used the most times
      Dim most As Long
      Dim n2 As Long
      
      For n2 = 0 To ((v2 * v2) - 1)
      most = mcolor(n2, 0)
      For n = 0 To ((v2 * v2) - 1)
      If (mcolor(n, 0) = most) Then mcolor(n, 1) = mcolor(n, 1) + 1
      Next n
      Next n2
      '
      Dim max As Long
      Dim mindex As Long
      max = mcolor(0, 1)
      mindex = 0
      For n = 1 To ((v2 * v2) - 1)
      If (mcolor(n, 1) > max) Then
      max = mcolor(n, 1)
      mindex = n
      End If
      Next
      '
      If max < 2 Then
      r = tRBuffer(x, y)
      g = tGBuffer(x, y)
      b = tBBuffer(x, y)
      Else
      tempcolor = mcolor(mindex, 0)
      r = (tempcolor And &HFF&)
      g = ((tempcolor And &HFF00&) \ 256)
      b = ((tempcolor And &HFF0000) \ 65536)
      End If



      MainRBuffer(x, y) = r
      MainGBuffer(x, y) = g
      MainBBuffer(x, y) = b
    Next
     If (y Mod 10) = 1 Then Dogwaffle.Dog_SetProgress y * (100 / th)
  Next
  
  Dogwaffle.Dog_SetProgress 0

'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()

'and refresh the screen
Dogwaffle.Dog_Refresh

End Sub

