Attribute VB_Name = "Module1"

Sub Main()
'*** Median FILTER EXAMPLE ***
'sorts a pixels neibors by value and uses the middle value.

'not the worlds fastest implementation but OK.  It uses a simple bubble sort and stops half way because we only need the middle value.
'it might be useful to develope a simpler, 5 point version.
'it might also be good to inline the inner loop.  Among other things it will help illiminate 7 redundant averages.
'and I don't care what they say, those divides are still slow.

Dim x As Integer, y As Integer
Dim x2 As Integer, y2 As Integer
'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim sr As Long, sg As Long, sb As Long
Dim m() As Long
Dim alphabits As Byte
Dim OldPointer As Integer

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")


'set the mouse pointer

OldPointer = Dogwaffle.dog_SetMousePointer(11)

'lock buffer is actually implemented now
'but it must be paired with an unlockbuffer
'so if a routine can possibly fail, don't use it, or make sure the buffer gets unlocked in some fallback code...
Dogwaffle.Dog_Lock

'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
alphabits = Dogwaffle.Dog_GetAlphabits
'get a copy of the main buffers
Dim sRBuffer() As Byte
Dim sGBuffer() As Byte
Dim sBBuffer() As Byte
sRBuffer() = MainRBuffer()
sGBuffer() = MainGBuffer()
sBBuffer() = MainBBuffer()

       ReDim m(2, 8)

'process the buffers.
For y = 1 To th - 2
    For x = 1 To tw - 2
        a = MainABuffer(x - 1, y)
        r = sRBuffer(x, y)
        g = sGBuffer(x, y)
        b = sBBuffer(x, y)
        sr = r
        sg = g
        sb = b
        m(0, 0) = r
        m(1, 0) = g
        m(2, 0) = b
        m(0, 1) = sRBuffer(x - 1, y)
        m(1, 1) = sGBuffer(x - 1, y)
        m(2, 1) = sBBuffer(x - 1, y)
        m(0, 2) = sRBuffer(x - 1, y - 1)
        m(1, 2) = sGBuffer(x - 1, y - 1)
        m(2, 2) = sBBuffer(x - 1, y - 1)
        m(0, 3) = sRBuffer(x, y - 1)
        m(1, 3) = sGBuffer(x, y - 1)
        m(2, 3) = sBBuffer(x, y - 1)
        m(0, 4) = sRBuffer(x + 1, y - 1)
        m(1, 4) = sGBuffer(x + 1, y - 1)
        m(2, 4) = sBBuffer(x + 1, y - 1)
        m(0, 5) = sRBuffer(x + 1, y)
        m(1, 5) = sGBuffer(x + 1, y)
        m(2, 5) = sBBuffer(x + 1, y)
        m(0, 6) = sRBuffer(x + 1, y + 1)
        m(1, 6) = sGBuffer(x + 1, y + 1)
        m(2, 6) = sBBuffer(x + 1, y + 1)
        m(0, 7) = sRBuffer(x, y + 1)
        m(1, 7) = sGBuffer(x, y + 1)
        m(2, 7) = sBBuffer(x, y + 1)
        m(0, 8) = sRBuffer(x - 1, y + 1)
        m(1, 8) = sGBuffer(x - 1, y + 1)
        m(2, 8) = sBBuffer(x - 1, y + 1)
        '

        'get the median
        'bubble sort, then get the middle.
        'Oh, those are so slow...
        Dim av As Long, av1 As Long
        Dim n2 As Integer
        
        For n = 0 To 8
        '
        For n2 = 0 To 7
        'find average
        av = (m(0, n2) + m(1, n2) + m(2, n2)) \ 3
        av1 = (m(0, n2 + 1) + m(1, n2 + 1) + m(2, n2 + 1)) \ 3
        If av1 > av Then
        'swap
        r = m(0, n2): m(0, n2) = m(0, n2 + 1): m(0, n2 + 1) = r
        g = m(1, n2): m(1, n2) = m(1, n2 + 1): m(1, n2 + 1) = g
        b = m(2, n2): m(2, n2) = m(2, n2 + 1): m(2, n2 + 1) = b
        End If
        Next
        
        Next
        'get middle
        r = m(0, 4)
        g = m(1, 4)
        b = m(2, 4)

        
        
        'handle alpha channel
        a = a Or alphabits 'if there's an alhpa but it's disabled
        a2 = 255 - a
        r = ((sr * a2) + (r * a)) \ 255
        g = ((sg * a2) + (g * a)) \ 255
        b = ((sb * a2) + (b * a)) \ 255
         
        MainRBuffer(x, y) = r
        MainGBuffer(x, y) = g
        MainBBuffer(x, y) = b
        
    Next
        'set the progress bar for each full line
    Call Dogwaffle.Dog_SetProgress(y * (100 / th))
Next

'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()
Dogwaffle.Dog_Refresh


'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0


Dogwaffle.dog_SetMousePointer (OldPointer)
Dogwaffle.Dog_unLock

End Sub









