Attribute VB_Name = "Module1"

Sub Main()
'*** Mirrage FILTER EXAMPLE ***


Dim x As Integer, y As Integer
Dim x2 As Integer, y2 As Integer
'these could have been byte length, but i'm multiplying by 255 down below, so i would have gotten overflow.  Could have worked around it, but oh well.
Dim r As Long, g As Long, b As Long, a As Long, a2 As Long
Dim r2 As Long, g2 As Long, b2 As Long
Dim sr As Long, sg As Long, sb As Long
Dim alphabits As Byte

'create a dogwaffle object
Dim Dogwaffle As Object
Set Dogwaffle = CreateObject("Dogwaffle.Dogwaffle_Class")



'get the width and height of the buffer
th = Dogwaffle.Dog_BufferHeight
tw = Dogwaffle.Dog_BufferWidth

'get the buffers
Dim MainRBuffer() As Byte
Dim MainGBuffer() As Byte
Dim MainBBuffer() As Byte
Dim MainABuffer() As Byte
MainRBuffer() = Dogwaffle.Dog_GetRBuffer
MainGBuffer() = Dogwaffle.Dog_GetGBuffer
MainBBuffer() = Dogwaffle.Dog_GetBBuffer
MainABuffer() = Dogwaffle.Dog_GetABuffer 'alpha
alphabits = Dogwaffle.Dog_GetAlphabits
'get a copy of the main buffers
Dim sRBuffer() As Byte
Dim sGBuffer() As Byte
Dim sBBuffer() As Byte
sRBuffer() = MainRBuffer()
sGBuffer() = MainGBuffer()
sBBuffer() = MainBBuffer()

       ReDim m(2, 4)

Dim ystp As Integer

'process the buffers.
For y = 1 To th - 2
    For x = 1 To tw - 2
        a = MainABuffer(x - 1, y)
        r = sRBuffer(x, y)
        g = sGBuffer(x, y)
        b = sBBuffer(x, y)
        '
        r2 = sRBuffer(x, th - y)
        g2 = sGBuffer(x, th - y)
        b2 = sBBuffer(x, th - y)
        '
        sr = r
        sg = g
        sb = b
        '
        r = ((r2 * y) + (r * (th - y))) / th
        g = ((g2 * y) + (g * (th - y))) / th
        b = ((b2 * y) + (b * (th - y))) / th
    
        'handle alpha channel
        a = a Or alphabits 'if there's an alhpa but it's disabled
        a2 = 255 - a
        r = ((sr * a2) + (r * a)) / 255
        g = ((sg * a2) + (g * a)) / 255
        b = ((sb * a2) + (b * a)) / 255
         
        MainRBuffer(x, y) = r
        MainGBuffer(x, y) = g
        MainBBuffer(x, y) = b
        
    Next
        'set the progress bar for each full line
    ystp = ystp + 1
    If ystp >= 10 Then
    ystp = 0
    Call Dogwaffle.Dog_SetProgress((y * (100 / th)))
    End If
Next

'send the buffers back to dogwaffle.
Dogwaffle.Dog_SetRbuffer MainRBuffer()
Dogwaffle.Dog_SetGbuffer MainGBuffer()
Dogwaffle.Dog_SetBbuffer MainBBuffer()
Dogwaffle.Dog_Refresh


'allways reset the progress bar if your using it. (and you should)
Dogwaffle.Dog_SetProgress 0


End Sub









